<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelType extends AbstractStructArrayBase
{
    /**
     * The HotelType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelType[]
     */
    public $HotelType;
    /**
     * Constructor method for ArrayOfJP_HotelType
     * @uses ArrayOfJP_HotelType::setHotelType()
     * @param \StructType\JP_HotelType[] $hotelType
     */
    public function __construct(array $hotelType = array())
    {
        $this
            ->setHotelType($hotelType);
    }
    /**
     * Get HotelType value
     * @return \StructType\JP_HotelType[]|null
     */
    public function getHotelType()
    {
        return $this->HotelType;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelTypeForArrayConstraintsFromSetHotelType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_HotelTypeHotelTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelTypeHotelTypeItem instanceof \StructType\JP_HotelType) {
                $invalidValues[] = is_object($arrayOfJP_HotelTypeHotelTypeItem) ? get_class($arrayOfJP_HotelTypeHotelTypeItem) : sprintf('%s(%s)', gettype($arrayOfJP_HotelTypeHotelTypeItem), var_export($arrayOfJP_HotelTypeHotelTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelType property can only contain items of type \StructType\JP_HotelType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelType[] $hotelType
     * @return \ArrayType\ArrayOfJP_HotelType
     */
    public function setHotelType(array $hotelType = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelTypeArrayErrorMessage = self::validateHotelTypeForArrayConstraintsFromSetHotelType($hotelType))) {
            throw new \InvalidArgumentException($hotelTypeArrayErrorMessage, __LINE__);
        }
        $this->HotelType = $hotelType;
        return $this;
    }
    /**
     * Add item to HotelType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelType $item
     * @return \ArrayType\ArrayOfJP_HotelType
     */
    public function addToHotelType(\StructType\JP_HotelType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelType) {
            throw new \InvalidArgumentException(sprintf('The HotelType property can only contain items of type \StructType\JP_HotelType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelType
     */
    public function getAttributeName()
    {
        return 'HotelType';
    }
}
